      subroutine addspinorbit(nv,hmatso,hmat,smat)
c
c	Including the spin-orbit coupling will result in doubling
c	size of the secular equation from nv to 2*nv.
c=======================================================================
c
	implicit real*8 (a-h,o-z)
	include 'P1'
	complex*16 hmat(mh*(mh+1)/2),smat(mh*(mh+1)/2)
	complex*16 hmatso(mh*(mh+1)/2)
        parameter (zero = 0d0)
c

        complex*16 hmatfull(mh,mh)
        complex*16 smatfull(mh,mh)
        complex*16 hmat2d(mh/2,mh/2)
        complex*16 smat2d(mh/2,mh/2)
        SR3=SQRT(3.0)
c
c     nv is the size of the basis set, without spin
c     hmat and smat are the Hamiltonian and Overlap matrices for the
c      current k-point, stored in triangular form.  On input they hold
c      the average-spin matrix elements, from element (1,1) to (nv,nv).
c      On output they contain the full spin-corrected matrix, from
c      (1,1) to (2*nv,2*nv).
c     Non-zero matrix elements will be printed at the end.
c
c Spin-orbit matrix in triangular form
c
c
c=======================================================================
c     In triangular storage format, if j > i, then matrix element
c      H(j,i) is stored in hmat(j*(j-1)/2+i)
c======================================================================= 
c
c       Adding the spin-orbit term we use two steps:
c	1. Duplicate the spin-up block in the spin-down block
c	2. Add the spin-orbit matrix to hmat(j*(j-1)/2+i)
cvvvv
      do j = 1,nv
         do i = 1,j
            hmat((j+nv)*(j+nv-1)/2+i+nv) = hmat(j*(j-1)/2+i)
            smat((j+nv)*(j+nv-1)/2+i+nv) = smat(j*(j-1)/2+i)
         end do
      end do
cvvvv
      do j = 1,nv
         do i = 1,nv
c           Zero this element in the spin-down/spin-up/ mixing block:
            hmat((j+nv)*(j+nv-1)/2+i) = dcmplx(zero,zero)
            smat((j+nv)*(j+nv-1)/2+i) = dcmplx(zero,zero)
         end do
      end do
c===================================================================
c 
c      do i=1, mh
c          do j=1, mh 
c              hmatfull(j,i)=dcmplx(0.0,0.0)
c              smatfull(j,i)=dcmplx(0.0,0.0)
c          enddo 
c      enddo
c
c      do i=1, mh/2 
c          do j=1, mh/2 
c              hmat2d(j,i)=dcmplx(0.0,0.0)
c              smat2d(j,i)=dcmplx(0.0,0.0)
c          enddo 
c      enddo
c
c      do i=1, mh/2 
c          do j=1, i
c              hmat2d(j,i)=hmat(i*(i-1)/2+j)
c              smat2d(j,i)=smat(i*(i-1)/2+j)
c          enddo 
c      enddo
c
c          hmatfull(1:mh/2,1:mh/2)=hmat2d
c          hmatfull(mh/2+1:mh, mh/2+1:mh)=hmat2d
c
c          smatfull(1:mh/2,1:mh/2)=hmat2d
c          smatfull(mh/2+1:mh, mh/2+1:mh)=hmat2d
c         
c!         write (*,*)   'H0'
c!         write (*,*)   real(hmatfull) 
c         !write (*,*)   'Overlap'
c         !write (*,*)   real(smatfull) 
c
c          k=1
c          do i=1, mh
c              do j=1, i
c                  hmat(k)=hmatfull(j,i)
c                  smat(k)=smatfull(j,i)
c                  k=k+1
c              enddo 
c          enddo
c
cc        Hfull=H0+Hso
         do mij = 1,mh*(mh+1)/2
            hmat(mij)=hmat(mij)+hmatso(mij)
         end do

      return
      end
