         subroutine spinorbitham (ib,theta1,phi1,hmatso)
c        subroutine spinorbitham (psop,dsop,theta1,phi1,hmatso)
c
c     Calculates the spin orbit matrix
c=======================================================================
	implicit real*8 (a-h,o-z)
        include 'P1'  !where mh is defined
	complex*16 hmatso(mh*(mh+1)/2)

c       common/codes/posn(matom,3),kkind(matom),natoms,pdsov(matom,2)
        common/codes/posn(matom,3),pdsov(matom,2),kkind(matom),natoms
        parameter (zero = 0d0)

        SR3=SQRT(3.0)
c
c     nv is the size of the basis set, without spin
c     hmat and smat are the Hamiltonian and Overlap matrices for the
c      current k-point, stored in triangular form.  On input they hold
c      the average-spin matrix elements, from element (1,1) to (nv,nv).
c      On output they contain the full spin-corrected matrix, from
c      (1,1) to (2*nv,2*nv).
c     Non-zero matrix elements will be printed at the end.
c
c
        sinf=sin(phi1)
        cosf=cos(phi1)
        sint=sin(theta1)
        cost=cos(theta1)

         do mij = 1,mh*(mh+1)/2
            hmatso(mij)=dcmplx(zero,zero)
         end do

         psop=pdsov(ib,1)
         dsop=pdsov(ib,2)
         write(*,*)'pdsov for atom', ib, psop,dsop
c
	hmatso(5)=dcmplx(0,cost)
	hmatso(8)=dcmplx(0,-sinf*sint)
	hmatso(9)=dcmplx(0,cosf*sint)
c
	hmatso(20)=dcmplx(0,-cost)
	hmatso(26)=dcmplx(0,sinf*sint)
	hmatso(27)=dcmplx(0,-cosf*sint)
	hmatso(33)=dcmplx(0,cosf*sint)
	hmatso(34)=dcmplx(0,sinf*sint)
	hmatso(35)=dcmplx(0,-2.0*cost)
	hmatso(41)=dcmplx(0,SR3*cosf*sint)
	hmatso(42)=dcmplx(0,-SR3*sinf*sint)
c
	hmatso(58)=dcmplx(0,sint)
	hmatso(59)=dcmplx(-cost,sinf*cost)
	hmatso(68)=dcmplx(0,-sint)
	hmatso(70)=dcmplx(-sinf,-cosf*cost)
	hmatso(77)=dcmplx(0,-cost)
	hmatso(80)=dcmplx(cosf,-sinf*cost)
	hmatso(81)=dcmplx(sinf,cosf*cost)
	hmatso(89)=dcmplx(0,sinf*sint)
	hmatso(90)=dcmplx(0,-cosf*sint)
c
	hmatso(97)=dcmplx(0,-sint)
	hmatso(98)=dcmplx(cosf,-sinf*cost)
	hmatso(99)=dcmplx(-sinf,-cosf*cost)
	hmatso(100)=dcmplx(-SR3*sinf,-SR3*cosf*cost)
	hmatso(110)=dcmplx(0,sint)
	hmatso(112)=dcmplx(sinf,cosf*cost)
	hmatso(113)=dcmplx(cosf,-sinf*cost)
	hmatso(114)=dcmplx(-SR3*cosf,SR3*sinf*cost)
	hmatso(119)=dcmplx(0,cost)
	hmatso(125)=dcmplx(-cosf,sinf*cost)
	hmatso(126)=dcmplx(-sinf,-cosf*cost)
	hmatso(128)=dcmplx(0,-2.0*sint)
	hmatso(134)=dcmplx(0,-sinf*sint)
	hmatso(135)=dcmplx(0,cosf*sint)
	hmatso(141)=dcmplx(sinf,cosf*cost)
	hmatso(142)=dcmplx(-cosf,sinf*cost)
	hmatso(143)=dcmplx(0,2.0*sint)
	hmatso(150)=dcmplx(0,-cosf*sint)
	hmatso(151)=dcmplx(0,-sinf*sint)
	hmatso(152)=dcmplx(0,2.0*cost)
	hmatso(158)=dcmplx(SR3*sinf,SR3*cosf*cost)
	hmatso(159)=dcmplx(SR3*cosf,-SR3*sinf*cost)
	hmatso(167)=dcmplx(0,-SR3*cosf*sint)
	hmatso(168)=dcmplx(0,SR3*sinf*sint)
c
         do mij = 1,10
            hmatso(mij)=0.5*psop*hmatso(mij)
         end do
c
         do mij = 11,45
            hmatso(mij)=0.5*dsop*hmatso(mij)
         end do
c
         do mij = 46,91
            hmatso(mij)=0.5*psop*hmatso(mij)
         end do
c
         do mij = 92,171
            hmatso(mij)=0.5*dsop*hmatso(mij)
         end do

c         do i = 1,171
c         write(15,*)(hmatso(i),i=1,171)
c         end do

      return
      end
