         subroutine spinorbithamN (theta1,phi1,hmatso)
c        subroutine spinorbithamN (psop,dsop,theta1,phi1,hmatso)
c
c     Calculates the spin orbit matrix
c=======================================================================
	implicit real*8 (a-h,o-z)
        include 'P1'  !where mh is defined
	complex*16 hmatso(mh*(mh+1)/2)
        parameter (zero = 0d0)
c  po-hao
        integer  i,j,k,ib
        integer,parameter :: nob=mbas ! number of orbitals (basis) per atom (without spin)
c        common/codes/posn(matom,3),kkind(matom),natoms,pdsov(matom,2)
        common/codes/posn(matom,3),pdsov(matom,2),kkind(matom),natoms
        integer,parameter :: nd0=nob*2
c        integer,parameter :: nd=nd0*natoms ! total size

        complex*16 hmat2d(nd0,nd0)
        complex*16 hmatuu(nob,nob)  
        complex*16 hmatdd(nob,nob)
        complex*16 hmatud(nob,nob)
        complex*16 hmatfull(nd0*natoms,nd0*natoms)  ! nd=nd0*natoms

c  po-hao
c initialize
c     write(*,*) "pdsov",pdsov
      nd=nd0*natoms
      do i=1, nd0
          do j=1, nd0 
              hmat2d(j,i)=dcmplx(0.0,0.0)
          enddo 
      enddo
      do i=1, nd
          do j=1, nd 
              hmatfull(j,i)=dcmplx(0.0,0.0)
          enddo 
      enddo

      !-----------------------------------------
      !triangular form of hamiltonian is defined here
      !k=1
      !do i=1, nd0
      !    do j=1, i
      !        hmatso(k)=dcmplx( (i*(i-1)/2+j), 0.0)
      !        k=k+1
      !    enddo 
      !enddo
            
      ! create full expanded hamiltonian assigned to corresponding block
      
      do ib=1, natoms ! loop over atoms 
      ! the size of hmatso can be shrink to only the size of one atom 
      ! spinorbitham should be called over each different atom 

          call spinorbitham(ib,theta1,phi1,hmatso)
c         call spinorbitham(psop(ib),dsop(ib),theta1,phi1,hmatso)

          ! convert the original triangular 1-D array to a 2D matrix  
          do i=1, nd0
              do j=1, i
                  hmat2d(j,i)=hmatso(i*(i-1)/2+j)
              enddo 
          enddo
      
          hmatuu=hmat2d(1:nob,1:nob)
          hmatdd=hmat2d(nob+1:2*nob ,nob+1:2*nob)
          hmatud=hmat2d(1:nob,nob+1:2*nob)
          !write (*,*)  'hmatuu'
          !write (*,*)  aimag(hmatuu)

      hmatfull((ib-1)*nob+1:ib*nob,(ib-1)*nob+1:ib*nob )=hmatuu
      hmatfull((ib-1)*nob+1:ib*nob,(ib-1)*nob+1+nd/2:ib*nob+nd/2)=hmatud
      hmatfull((ib-1+natoms)*nob+1:(ib+natoms)*nob,(ib+natoms-1)*nob+1
     $   :(ib+natoms)*nob) =hmatdd

      enddo  ! loop over atoms
          
          k=1
          do i=1, nd
              do j=1, i
                  hmatso(k)=hmatfull(j,i)
                  k=k+1
              enddo 
          enddo
          !write (*,*)   aimag(hmatso) 
          !write (*,*)   real(hmatso) 
      return
      end
